#ifdef _WIN32
	#pragma warning(disable:4996)
	#include <conio.h>
	#include <direct.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <stdlib.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <iostream>
#include <iomanip>
using namespace std;

#include "MaticaObdlznikova.h"
//---------------------------------------------------------------------------
// This is a default constructor to initiate the base class 'TMaticaObdlznikova' 
// for childs
TMaticaObdlznikova::TMaticaObdlznikova()
{
	Matica = NULL; // dolezite
}
//---------------------------------------------------------------------------
//Konstruktor dynamicky alokuje pamat pre prvky matice a inicializuje ich
TMaticaObdlznikova::TMaticaObdlznikova(const unsigned m, const unsigned n)
{
	unsigned i,j;

	PocetRiadkov = m;
	PocetStlpcov = n;

	Matica = new long double*[PocetRiadkov];         // pocet [] a * je 3
	for (i=0;i<PocetRiadkov;i++)
		Matica[i] = new long double[PocetStlpcov];    // pocet [] je 3

	for (i=0; i<PocetRiadkov; i++)
		for (j=0; j<PocetStlpcov; j++)
			Matica[i][j]=0;
}
//---------------------------------------------------------------------------
//Kopirovaci konstruktor
TMaticaObdlznikova::TMaticaObdlznikova(TMaticaObdlznikova& X)
{
	unsigned i,j;

	PocetRiadkov = X.PocetRiadkov;
	PocetStlpcov = X.PocetStlpcov;

	Matica = new long double*[PocetRiadkov];         // pocet [] a * je 3
	for (i=0;i<PocetRiadkov;i++)
		Matica[i] = new long double[PocetStlpcov];    // pocet [] je 3

	for (i=0;i<PocetRiadkov;i++)
		for (j=0;j<PocetStlpcov;j++)
			Matica[i][j] = X.Matica[i][j];
}
//---------------------------------------------------------------------------
//Destruktor upratuje alokovanu pamat
TMaticaObdlznikova::~TMaticaObdlznikova()
{
	if (Matica != NULL) {
		for (unsigned i=0;i<PocetRiadkov;i++)
			delete[] Matica[i];
		delete[] Matica;
		Matica = NULL;
	}
}
//---------------------------------------------------------------------------
TMaticaObdlznikova& TMaticaObdlznikova::operator=(const TMaticaObdlznikova& X)
{
	if (this == &X) return *this;

	for (unsigned i=0;i<PocetRiadkov;i++)
		for (unsigned j=0;j<PocetStlpcov;j++)
			Matica[i][j] = X.Matica[i][j];

	return *this;
}
//---------------------------------------------------------------------------
const TMaticaObdlznikova operator+(const TMaticaObdlznikova& LavaMatica,
	const TMaticaObdlznikova& PravaMatica)
{
	TMaticaObdlznikova VyslMatica(LavaMatica.PocetRiadkov, LavaMatica.PocetStlpcov);

	for (unsigned i=0; i<LavaMatica.PocetRiadkov; i++)
		for (unsigned j=0; j<LavaMatica.PocetStlpcov; j++)
			VyslMatica.Matica[i][j] = LavaMatica.Matica[i][j]+PravaMatica.Matica[i][j];

	return VyslMatica;
}
//---------------------------------------------------------------------------
const TMaticaObdlznikova operator*(const TMaticaObdlznikova& LavaMatica,
	const TMaticaObdlznikova& PravaMatica)
{
	TMaticaObdlznikova VyslMatica(LavaMatica.PocetRiadkov, LavaMatica.PocetStlpcov);
	my_class xx;

	unsigned i,j,k;
   long double Suma;

   if (LavaMatica.PocetStlpcov!=PravaMatica.PocetRiadkov){
		cout << "\n  Matice sa nedaju nasobit!\n";
		xx.my_getch();
	}
   for (i=0; i<LavaMatica.PocetRiadkov; i++)
		for (j=0; j<PravaMatica.PocetStlpcov; j++){
			Suma=0;
			for (k=0; k<LavaMatica.PocetStlpcov; k++)
				Suma+=LavaMatica.Matica[i][k]*PravaMatica.Matica[k][j];
			VyslMatica.Matica[i][j]=Suma;
		}
	return VyslMatica;
}
//---------------------------------------------------------------------------
TMaticaObdlznikova& TMaticaObdlznikova::operator+=(const TMaticaObdlznikova& 
	PravaMatica)
{
	*this = *this + PravaMatica;
	return *this;
}
//---------------------------------------------------------------------------
TMaticaObdlznikova& TMaticaObdlznikova::operator*=(const TMaticaObdlznikova& 
	PravaMatica)
{
	*this = *this * PravaMatica;
	return *this;
}
//---------------------------------------------------------------------------
istream& operator>>(istream& is, TMaticaObdlznikova& X)
{
	my_class xx;

	for (unsigned i=0;i<X.PocetRiadkov;i++)
		for (unsigned j=0;j<X.PocetStlpcov;j++)
			is >> X.Matica[i][j];
	if (is.fail()){
		cout << "\n\n  Vstupny subor sa nepodarilo otvorit.\n";
		xx.my_getch();
		exit(1);
	}

	return is;
}
//---------------------------------------------------------------------------
ostream& operator<<(ostream& os,const TMaticaObdlznikova& X)
{
	os.setf(ios::fixed,ios::floatfield);
	os.precision(2);
	for (unsigned i=0;i<X.PocetRiadkov;i++) {
		os << "\n  ";
		for (unsigned j=0;j<X.PocetStlpcov;j++)
			os << setw(8) << X.Matica[i][j];
	}
	os << "\n";

	return os;
}
//---------------------------------------------------------------------------
void my_class::my_getch() const
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------

